//
//  LoginViewController.m
//  Car
//
//  Created by Javen on 2016/12/23.
//  Copyright © 2016年 上海勾芒信息科技. All rights reserved.
//

#import "LoginViewController.h"
#import "MainViewController.h"
#import "LeftTableViewController.h"
#import "WWSideslipViewController.h"
#import "HttpCilent.h"
@interface LoginViewController ()
@property(weak, nonatomic) IBOutlet UITextField *textFieldUser;
@property(weak, nonatomic) IBOutlet UITextField *textFieldPsw;

@end

@implementation LoginViewController

- (void)viewDidLoad {
  [super viewDidLoad];
  [self configUI];
  // Do any additional setup after loading the view.
}

- (void)configUI {
  self.textFieldUser.text = kGlobal.userName;
  self.textFieldPsw.text = kGlobal.userPsw;
}

#pragma mark - actions
- (IBAction)actionLogin:(id)sender {
  kCanNotBeNil(self.textFieldUser.text, @"工号不能为空！");
  kCanNotBeNil(self.textFieldPsw.text, @"密码不能为空！");

  NSDictionary *myDictionary = @{
    @"userName" : self.textFieldUser.text,
    @"password" : self.textFieldPsw.text,
    @"longitude" : @"30.9813540",
    @"latitude" : @"121.7236680"
  };
  WS(weakSelf);
  [MBProgressHUD j_loading:@"登录中…"];
  [kHttp POST:kLoginUrl
      parameters:myDictionary
        complete:^(id _Nullable response, NSError *_Nullable error) {
          [MBProgressHUD j_hideLoadingView];
          if (response) {
            UINavigationController *mainNaVC =
                [self storyboardType:STORYBOARD_TYPE_MAIN
                          identifier:@"MainNavigationController"];
            LeftTableViewController *leftVC = [LeftTableViewController
                viewControllerWithStoryBoardType:STORYBOARD_TYPE_MAIN];
            WWSideslipViewController *sideVC = [[WWSideslipViewController alloc]
                  initWithLeftView:leftVC
                       andMainView:mainNaVC
                      andRightView:nil
                andBackgroundImage:[UIImage imageNamed:@"side_bg"]];

            kGlobal.loginResult =
                [[LoginResult alloc] initWithDictionary:response[@"data"]
                                                  error:nil];
            kGlobal.sideSlipVC = sideVC;
            kGlobal.userName = weakSelf.textFieldUser.text;
            kGlobal.userPsw = weakSelf.textFieldPsw.text;
            sideVC.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
            [self presentViewController:sideVC animated:YES completion:nil];
          }
        }];
}

- (void)didReceiveMemoryWarning {
  [super didReceiveMemoryWarning];
  // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little
preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
