//
//  MainViewController.m
//  Car
//
//  Created by Javen on 2016/12/23.
//  Copyright © 2016年 上海勾芒信息科技. All rights reserved.
//

#import "MainViewController.h"
#import "HttpCilent.h"
#import "OrderListTableViewCell.h"
#import "OrderListModel.h"
@interface MainViewController ()

@end

@implementation MainViewController

- (void)viewDidLoad {
    [super viewDidLoad];
  [self httpRequest];
}

- (void)httpRequest {
  NSDictionary *myDictionary = @{@"orders" : @[@{@"field" : @"payTime",
                                                 @"direction" : @"desc"}],
                                 @"pageNumber" : @(self.page),
                                 @"pageSize" : @(self.pageSize),
                                 @"userId" : kUser.fid,
                                 @"userNameLike" : [NSNull null],
                                 @"billNumberLike" : [NSNull null],
                                 @"endDate" : [NSNull null],
                                 @"state" : @"paid"};
  
  WS(weakSelf);
  [kHttp POST:kOrderQuery parameters:myDictionary complete:^(id  _Nullable response, NSError * _Nullable error) {
    if ([response[@"code"] isEqualToNumber:@0]) {
      for (NSDictionary *dict in response[@"data"][@"records"]) {
        OrderListModel *model = [[OrderListModel alloc] initWithDictionary:dict error:nil];
        [weakSelf.arrData addObject:model];
      }
      [weakSelf listTableViewReloadData];
      
    }else{
      if (self.page > 0) {
        self.page--;
      }
    }
    
  }];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
  return 166;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
  return self.arrData.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
  OrderListTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"OrderListTableViewCell" forIndexPath:indexPath];
  [cell configCellArray:self.arrData indexPath:indexPath];
  return cell;
}

#pragma mark - actions
- (IBAction)actionLeft:(UIBarButtonItem *)sender {
  [kGlobal.sideSlipVC showLeftView];
}

- (IBAction)actionRight:(id)sender {
  
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


@end
